=== debian/changelog ===
openl2tp (1.8-1) unstable; urgency=low

  * Built from upstream version.

 -- James Chapman <jchapman@openl2tp.org>  Mon, 22 Nov 2010 12:27:19 +0000
